﻿Imports System.Xml
Imports System.Text
Imports System.Security.Cryptography

Public Class Options_Dialog
    Public GWconf As String = "GWconf.xml"
    Public key() As Byte = {12, 56, 67, 27, 83, 223, 45, 71, 1}
    Public iv() As Byte = {23, 239, 54, 178, 32, 211, 23, 164}

    Public Function enCrypt(ByVal inPut As String)
        Dim textConverter = New UTF8Encoding()
        Dim rc2CSP = New RC2CryptoServiceProvider()
        Dim toEncrypt = textConverter.GetBytes(inPut)

        Dim encryptor As ICryptoTransform = rc2CSP.CreateEncryptor(key, iv)

        Dim msEncrypt = New System.IO.MemoryStream
        Dim csEncrypt = New CryptoStream(msEncrypt, encryptor, CryptoStreamMode.Write)

        Dim length() As Byte = {0, 0, 0, 0}

        length(0) = inPut.Length
        length(1) = (inPut.Length >> 8)
        length(2) = (inPut.Length >> 16)
        length(3) = (inPut.Length >> 24)
        csEncrypt.Write(length, 0, 4)
        csEncrypt.Write(toEncrypt, 0, toEncrypt.Length)
        csEncrypt.FlushFinalBlock()

        Dim encrypted = msEncrypt.ToArray
        Dim b64 = Convert.ToBase64String(encrypted)

        Return b64

        b64 = Nothing
        encrypted = Nothing
        csEncrypt = Nothing
        msEncrypt = Nothing
        length = Nothing
        encryptor = Nothing
        toEncrypt = Nothing
        rc2CSP = Nothing
        textConverter = Nothing
        inPut = Nothing
    End Function

    Private Sub Options_Dialog_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.SetDesktopLocation(Me.Location.X, Root.Location.Y + 100)
        Dim doc As XmlDocument = New XmlDocument()
        If Not My.Computer.FileSystem.FileExists(GWconf) Then
            System.IO.File.WriteAllText(GWconf, "<?xml version=""1.0"" encoding=""utf-8"" standalone=""yes""?>" & vbNewLine & "<options>" & vbNewLine & "    <login></login>" & vbNewLine & "    <password></password>" & vbNewLine & "    <screenshot></screenshot>" & vbNewLine & "</options>")
        End If

        doc.Load(GWconf)
        If Not doc.SelectSingleNode("/options/login").InnerText = Nothing Then
            Login_Field.UseSystemPasswordChar = True
            Login_Field.Text = doc.SelectSingleNode("/options/login").InnerText
            Login_Field.Enabled = False
        End If
        If Not doc.SelectSingleNode("/options/password").InnerText = Nothing Then
            Password_Field.UseSystemPasswordChar = True
            Password_Field.Text = doc.SelectSingleNode("/options/password").InnerText
            Password_Field.Enabled = False
        End If
        If doc.SelectSingleNode("/options/screenshot").InnerText = "1" Then
            ScreenshotOptionCheck.Checked = True
        End If
        doc = Nothing
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim doc As XmlDocument = New XmlDocument()
        If Login_Field.Text = Nothing Or Password_Field.Text = Nothing Then
            MsgBox("You actually need to input ALL of your information...", MsgBoxStyle.Critical, "Alert")
        ElseIf (Not Login_Field.Enabled And Not Password_Field.Enabled) Then
            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.Close()
        Else
            doc.Load(GWconf)
            doc.SelectSingleNode("/options/login").InnerText = enCrypt(Login_Field.Text)
            doc.SelectSingleNode("/options/password").InnerText = enCrypt(Password_Field.Text)
            doc.Save(GWconf)
            Me.Close()
        End If
        doc = Nothing
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim oShell As Shell32.Shell = New Shell32.Shell
        Dim oFolder As Shell32.Folder = oShell.NameSpace(25)
        Dim oFolderItem As Shell32.FolderItem = oFolder.ParseName("Guild Wars.lnk")
        Dim oShellLink As Shell32.ShellLinkObject = oFolderItem.GetLink

        oShellLink.Path = My.Computer.FileSystem.CurrentDirectory & "\GWboot.exe"
        oShellLink.ShowCommand = 1
        oShellLink.SetIconLocation(My.Computer.FileSystem.CurrentDirectory & "\Gw.exe", 0)
        oShellLink.WorkingDirectory = My.Computer.FileSystem.CurrentDirectory
        oShellLink.Description = "Guild Wars"
        oShellLink.Save()

        oShellLink = Nothing
        oFolderItem = Nothing
        oFolder = Nothing
        oShell = Nothing

        MsgBox("Shortcut updated to: " & My.Computer.FileSystem.CurrentDirectory & "\GWboot.exe", MsgBoxStyle.OkOnly)
        Me.Close()
    End Sub

    Private Sub Options_Dialog_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        key = Nothing
        iv = Nothing
        GWconf = Nothing
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Login_Field.Text = Nothing
        Login_Field.UseSystemPasswordChar = False
        Login_Field.Enabled = True
        Password_Field.Text = Nothing
        Password_Field.UseSystemPasswordChar = False
        Password_Field.Enabled = True
    End Sub

    Private Sub ScreenshotOptionCheck_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ScreenshotOptionCheck.CheckedChanged
        Dim doc As XmlDocument = New XmlDocument()
        doc.Load(GWconf)
        If ScreenshotOptionCheck.Checked Then
            doc.SelectSingleNode("/options/screenshot").InnerText = "1"
        ElseIf Not ScreenshotOptionCheck.Checked Then
            doc.SelectSingleNode("/options/screenshot").InnerText = "0"
        End If
        doc.Save(GWconf)
        doc = Nothing
    End Sub
End Class
